﻿Type.registerNamespace('ContextualTabWebPart');

///<summary>
/// When creating this object, you use the webPartPcId parameter to set the custom page component id.
/// This is set to the same value as the Web Part’s page component id to associate the Web Part and page component through the getId method.
///</summary>
ContextualTabWebPart.CustomPageComponent = function ContextualTabWebPart_CustomPageComponent(webPartPcId) {
    this._webPartPageComponentId = webPartPcId;
    ContextualTabWebPart.CustomPageComponent.initializeBase(this);
}

ContextualTabWebPart.CustomPageComponent.prototype = {

    init: function ContextualTabWebPart_CustomPageComponent$init() { },

    ///<summary>
    /// Returns the Command properties that you defined in the ribbon XML.
    ///</summary>
    getFocusedCommands: function ContextualTabWebPart_CustomPageComponent$getFocusedCommands() {
        return ['CustomContextualTab.EnableCustomTab',
            'CustomContextualTab.EnableCustomGroup',
            'CustomContextualTab.HelloWorldCommand',
            'CustomContextualTab.GoodbyeWorldCommand'];
    },

    getGlobalCommands: function ContextualTabWebPart_CustomPageComponent$getGlobalCommands() {
        return [];
    },

    isFocusable: function ContextualTabWebPart_CustomPageComponent$isFocusable() {
        return true;
    },

    ///<summary>
    /// Return true to signify that your page component can respond to the specified commands.
    ///</summary>
    canHandleCommand: function ContextualTabWebPart_CustomPageComponent$canHandleCommand(commandId) {
        //Contextual Tab commands
        if ((commandId === 'CustomContextualTab.EnableCustomTab')
            || (commandId === 'CustomContextualTab.EnableCustomGroup')
            || (commandId === 'CustomContextualTab.HelloWorldCommand')
            || (commandId === 'CustomContextualTab.GoodbyeWorldCommand'))
        {
            return true;
        }
    },

    handleCommand: function ContextualTabWebPart_CustomPageComponent$handleCommand(commandId, properties, sequence) {
        if (commandId === 'CustomContextualTab.HelloWorldCommand') {
            alert(this._webPartPageComponentId + ' says: Hello, world!');
        }
        if (commandId === 'CustomContextualTab.GoodbyeWorldCommand') {
            alert(this._webPartPageComponentId + ' says: Good-bye, world!');
        }
    },

    getId: function ContextualTabWebPart_CustomPageComponent$getId() {
        return this._webPartPageComponentId;
    }

}

ContextualTabWebPart.CustomPageComponent.registerClass('ContextualTabWebPart.CustomPageComponent', CUI.Page.PageComponent);
SP.SOD.notifyScriptLoadedAndExecuteWaitingJobs("CustomContextualTabPageComponent.js");
